#ifndef _DS8OUT_H_
#define _DS8OUT_H_

#include <windows.h>
#include <mmsystem.h>
#include <dsound.h>
#include "dumwdec.h"

#define DS8_PCMSTA_PLAY     1
#define DS8_PCMSTA_LOOP     2
#define DS8_PCMSTA_TERM     4
#define DS8_PCMSTA_LOST     8
#define DS8_PCMSTA_INVALID  16

typedef struct DS8OUT_ DS8OUT,*PDS8OUT;
typedef struct DS8PCMUNIT_ DS8PCMUNIT,*PDS8PCMUNIT;
typedef struct DS8PCMSTR_ DS8PCMSTR,*PDS8PCMSTR;

typedef PDUMVOID DUMCALLTYPE (*DS8CBALLOC)(PDUMVOID usr,DUMU4B size);
typedef void DUMCALLTYPE (*DS8CBFREE)(PDUMVOID usr,PDUMVOID mem);
typedef DUMS4B DUMCALLTYPE (*DS8CBOPEN)(PDUMVOID usr,DUMCSTR file,DUMU4B f);
typedef DUMS4B DUMCALLTYPE (*DS8CBOPENERRCODE)(PDUMVOID usr);
typedef DUMBOOL DUMCALLTYPE (*DS8CBISOPENERR)(PDUMVOID usr,DUMS4B fd);
typedef void DUMCALLTYPE (*DS8CBCLOSE)(PDUMVOID usr,DUMS4B fd);
typedef DUMU8B DUMCALLTYPE (*DS8CBSEEK)(PDUMVOID usr,DUMS4B fd,DUMS8B pos,DUMS4B mode);
typedef DUMU8B DUMCALLTYPE (*DS8CBREAD)(PDUMVOID usr,DUMS4B fd,PDUMVOID buf,DUMU8B size);
typedef DUMU8B DUMCALLTYPE (*DS8CBWRITE)(PDUMVOID usr,DUMS4B fd,PDUMVOID buf,DUMU8B size);
typedef DUMU4B DUMCALLTYPE (*DS8CBSAVETIME)(PDUMVOID usr);
typedef DUMBOOL DUMCALLTYPE (*DS8CBSAVEPRGRS)(PDUMVOID usr,DUMU4B now,DUMU4B max);
typedef DUMBOOL DUMCALLTYPE (*DS8CBFINDTEXT)(PDUMVOID usr,DUMCSTR str,DUMCSTR lang,DUMCSTR cset);

typedef struct DS8CBTBL_{
	/*Ǘn*/
	DS8CBALLOC alloc;
	DS8CBFREE free;
	/*t@CǗn*/
	DS8CBOPEN open;
	DS8CBOPENERRCODE openerrcode;
	DS8CBISOPENERR isopenerr;
	DS8CBCLOSE close;
	DS8CBSEEK seek;
	DS8CBREAD read;
	DS8CBWRITE write;
	}DS8CBTBL,*PDS8CBTBL;

typedef void DUMCALLTYPE (*DS8PURGE)(PDS8OUT ds8);
typedef void DUMCALLTYPE (*DS8LOCK)(PDS8OUT ds8);
typedef DWERRCODE DUMCALLTYPE (*DS8LOCKNW)(PDS8OUT ds8);
typedef void DUMCALLTYPE (*DS8UNLOCK)(PDS8OUT ds8);
typedef void DUMCALLTYPE (*DS8MUTE)(PDS8OUT ds8,DUMBOOL side);
typedef HRESULT DUMCALLTYPE (*DS8DEVOPEN)(PDS8OUT ds8,DUMCSTR name,DUMS4B ch,DUMS4B bit,DUMS4B freq,HWND hw,DUMU4B coop);
typedef void DUMCALLTYPE (*DS8DEVCLOSE)(PDS8OUT ds8);
typedef DUMU4B DUMCALLTYPE (*DS8PLUGDESC)(PDS8OUT ds8,DUMCSTR plug,DUMCSTRBUF buf,DUMU4B size);
typedef DUMU4B DUMCALLTYPE (*DS8PCMCOUNT)(PDS8OUT ds8,DUMCSTR file,DUMCSTR plug);
typedef DUMU4B DUMCALLTYPE (*DS8PCMTEXTCOUNT)(PDS8OUT ds8,DUMCSTR file,DUMCSTR plug,DUMU4B ch);
typedef DUMU4B DUMCALLTYPE (*DS8PCMTEXT)(PDS8OUT ds8,DUMCSTR file,DUMCSTR plug,DUMU4B ch,DUMS4B idx,DUMCSTRBUF buf,DUMU4B size);
typedef DUMU4B DUMCALLTYPE (*DS8PCMTEXTCSET)(PDS8OUT ds8,DUMCSTR file,DUMCSTR plug,DUMU4B ch,DUMS4B idx,DUMCSTRBUF buf,DUMU4B size);
typedef DUMU4B DUMCALLTYPE (*DS8PCMTEXTLANG)(PDS8OUT ds8,DUMCSTR file,DUMCSTR plug,DUMU4B ch,DUMS4B idx,DUMCSTRBUF buf,DUMU4B size);
typedef PDS8PCMUNIT DUMCALLTYPE (*DS8PCMLOAD)(PDS8OUT ds8,DUMCSTR file,DUMCSTR plug,DUMU4B ch,DUMU4B sw);
typedef PDS8PCMUNIT DUMCALLTYPE (*DS8PCMDUP)(PDS8PCMUNIT unit);
typedef void DUMCALLTYPE (*DS8PCMFREE)(PDS8PCMUNIT unit);
typedef HRESULT DUMCALLTYPE (*DS8PCMPLAY)(PDS8PCMUNIT unit,DUMU4B flg);
typedef void DUMCALLTYPE (*DS8PCMSTOP)(PDS8PCMUNIT unit);
typedef HRESULT DUMCALLTYPE (*DS8PCMVOL)(PDS8PCMUNIT unit,DUMS4B vol);
typedef HRESULT DUMCALLTYPE (*DS8PCMPAN)(PDS8PCMUNIT unit,DUMS4B pan);
typedef HRESULT DUMCALLTYPE (*DS8PCMPIT)(PDS8PCMUNIT unit,DUMS4B freq);
typedef HRESULT DUMCALLTYPE (*DS8PCMPOS)(PDS8PCMUNIT unit,DUMU4B pos);
typedef DUMU4B DUMCALLTYPE (*DS8PCMGETSTA)(PDS8PCMUNIT unit);
typedef PDS8PCMSTR DUMCALLTYPE (*DS8STRNEW)(PDS8OUT ds8,DUMU4B wait);
typedef void DUMCALLTYPE (*DS8STRFREE)(PDS8PCMSTR str);
typedef HRESULT DUMCALLTYPE (*DS8STROPEN)(PDS8PCMSTR str,DUMCSTR file,DUMCSTR plug,DUMU4B scale,DUMU4B ch,DUMU4B sw);
typedef void DUMCALLTYPE (*DS8STROPENNW)(PDS8PCMSTR str,DUMCSTR file,DUMCSTR plug,DUMU4B scale,DUMU4B ch,DUMU4B sw);
typedef void DUMCALLTYPE (*DS8STRCLOSE)(PDS8PCMSTR str);
typedef void DUMCALLTYPE (*DS8STRCLOSENW)(PDS8PCMSTR str);
typedef void DUMCALLTYPE (*DS8STRPLAY)(PDS8PCMSTR str);
typedef void DUMCALLTYPE (*DS8STRSTOP)(PDS8PCMSTR str);
typedef HRESULT DUMCALLTYPE (*DS8STRVOL)(PDS8PCMSTR str,DUMS4B vol);
typedef HRESULT DUMCALLTYPE (*DS8STRPAN)(PDS8PCMSTR str,DUMS4B pan);
typedef HRESULT DUMCALLTYPE (*DS8STRPIT)(PDS8PCMSTR str,DUMS4B freq);
typedef void DUMCALLTYPE (*DS8STRSWITCH)(PDS8PCMSTR str,DUMU4B sw);
typedef DUMBOOL DUMCALLTYPE (*DS8STRISREADY)(PDS8PCMSTR str);
typedef DUMBOOL DUMCALLTYPE (*DS8STRISEND)(PDS8PCMSTR str);
typedef LPDIRECTSOUND DUMCALLTYPE (*DS8GETDS)(PDS8OUT ds8);
typedef LPDIRECTSOUNDBUFFER DUMCALLTYPE (*DS8GETDSPRI)(PDS8OUT ds8);
typedef LPDIRECTSOUNDBUFFER DUMCALLTYPE (*DS8GETDSSEC)(PDS8OUT ds8,PDS8PCMUNIT unit);
typedef DWERRCODE DUMCALLTYPE (*DS8SAVE)(PDS8OUT ds8,DUMCSTR file,DUMCSTR plug,DUMU4B ch,DUMU4B sw,DUMU4B mode,DUMCSTR save,DS8CBSAVETIME cbtime,DS8CBSAVEPRGRS cbprgrs);
typedef DWSETRES DUMCALLTYPE (*DS8STRSETPOSD)(PDS8PCMSTR str,DUMU8B pos);
typedef DUMU8B DUMCALLTYPE (*DS8STRGETPOSD)(PDS8PCMSTR str);
typedef DWSETRES DUMCALLTYPE (*DS8STRSETPOSS)(PDS8PCMSTR str,DUMF4B pos);
typedef DUMF4B DUMCALLTYPE (*DS8STRGETPOSS)(PDS8PCMSTR str);
typedef DWSETRES DUMCALLTYPE (*DS8STRSETENDD)(PDS8PCMSTR str,DUMU8B pos);
typedef DWSETRES DUMCALLTYPE (*DS8STRSETENDS)(PDS8PCMSTR str,DUMF4B pos);
typedef DWSETRES DUMCALLTYPE (*DS8STRSETLOOPD)(PDS8PCMSTR str,DUMU8B bgn,DUMU8B end);
typedef DWSETRES DUMCALLTYPE (*DS8STRSETLOOPS)(PDS8PCMSTR str,DUMF4B bgn,DUMF4B end);
typedef DWERRCODE DUMCALLTYPE (*DS8STRGETDECSTA)(PDS8PCMSTR str,PDWDECSTA buf,DUMU4B size);
typedef HRESULT DUMCALLTYPE (*DS8STRPREOPEN)(PDS8PCMSTR str,DUMCSTR file,DUMCSTR plug,DUMU4B scale,DUMU4B ch,DUMU4B sw,PDWDECSTA buf,DUMU4B size);
typedef void DUMCALLTYPE (*DS8ENUMPCMTEXT)(PDS8OUT ds8,DUMCSTR file,DUMCSTR plug,DUMU4B ch,DUMS4B kind,DS8CBFINDTEXT cb);

#define DS8PCMTEXTCS DS8PCMTEXTCSET

/*p~*/
typedef HRESULT DUMCALLTYPE (*DS8DEVOPEN_030)(PDS8OUT ds8,DUMCSTR name,DUMS4B ch,DUMS4B bit,DUMS4B freq,HWND hw,DUMU4B coop,DUMU4B scale,DUMU4B sfreq);
typedef PDS8PCMUNIT DUMCALLTYPE (*DS8PCMLOAD_030)(PDS8OUT ds8,DUMCSTR file,DUMCSTR plug);
typedef PDS8PCMUNIT DUMCALLTYPE (*DS8PCMDUP_030)(PDS8OUT ds8,PDS8PCMUNIT unit);
typedef void DUMCALLTYPE (*DS8PCMFREE_030)(PDS8OUT ds8,PDS8PCMUNIT unit);
typedef HRESULT DUMCALLTYPE (*DS8PCMPLAY_030)(PDS8OUT ds8,PDS8PCMUNIT unit,DUMU4B flg);
typedef void DUMCALLTYPE (*DS8PCMSTOP_030)(PDS8OUT ds8,PDS8PCMUNIT unit);
typedef HRESULT DUMCALLTYPE (*DS8PCMVOL_030)(PDS8OUT ds8,PDS8PCMUNIT unit,DUMS4B vol);
typedef HRESULT DUMCALLTYPE (*DS8PCMPAN_030)(PDS8OUT ds8,PDS8PCMUNIT unit,DUMS4B pan);
typedef HRESULT DUMCALLTYPE (*DS8PCMPIT_030)(PDS8OUT ds8,PDS8PCMUNIT unit,DUMS4B pit);
typedef HRESULT DUMCALLTYPE (*DS8PCMPOS_030)(PDS8OUT ds8,PDS8PCMUNIT unit,DUMU4B pos);
typedef DUMU4B DUMCALLTYPE (*DS8PCMGETSTA_030)(PDS8OUT ds8,PDS8PCMUNIT unit);
typedef HRESULT DUMCALLTYPE (*DS8STROPEN_030)(PDS8OUT ds8,DUMCSTR file,DUMCSTR plug);
typedef void DUMCALLTYPE (*DS8STRCLOSE_030)(PDS8OUT ds8);

typedef struct DS8OUT_{
	DS8PURGE purge;
	DS8DEVOPEN_030 devopen_030;
	DS8DEVCLOSE devclose;
	DS8PCMLOAD_030 pcmload_030;
	DS8PCMDUP_030 pcmdup_030;
	DS8PCMFREE_030 pcmfree_030;
	DS8PCMPLAY_030 pcmplay_030;
	DS8PCMSTOP_030 pcmstop_030;
	DS8PCMVOL_030 pcmvol_030;
	DS8PCMPAN_030 pcmpan_030;
	DS8PCMPIT_030 pcmpit_030;
	DS8PCMPOS_030 pcmpos_030;
	DS8PCMGETSTA_030 pcmgetsta_030;
	DS8STROPEN_030 stropen_030;
	DS8STRCLOSE_030 strclose_030;
	DS8GETDS getds;
	DS8GETDSPRI getdspri;
	DS8GETDSSEC getdssec;
	DS8LOCK lock;
	DS8LOCKNW locknw;
	DS8UNLOCK unlock;
	DS8MUTE mute;
	DS8DEVOPEN devopen;
	DS8PCMLOAD pcmload;
	DS8PCMDUP pcmdup;
	DS8PCMFREE pcmfree;
	DS8PCMPLAY pcmplay;
	DS8PCMSTOP pcmstop;
	DS8PCMVOL pcmvol;
	DS8PCMPAN pcmpan;
	DS8PCMPIT pcmpit;
	DS8PCMPOS pcmpos;
	DS8PCMGETSTA pcmgetsta;
	DS8STROPEN stropen;
	DS8STRCLOSE strclose;
	DS8STRNEW strnew;
	DS8STRFREE strfree;
	DS8STRPLAY strplay;
	DS8STRSTOP strstop;
	DS8STRVOL strvol;
	DS8STRPAN strpan;
	DS8STRPIT strpit;
	DS8STRSWITCH strswitch;
	DS8STROPENNW stropennw;
	DS8STRCLOSENW strclosenw;
	DS8STRISREADY strisready;
	DS8STRISEND strisend;
	DS8PCMCOUNT pcmcount;
	DS8PCMTEXTCOUNT pcmtextcount;
	DS8PCMTEXT pcmtext;
	DS8PCMTEXTCS pcmtextcs;
	DS8PLUGDESC plugdesc;
	DS8SAVE save;
	DS8STRSETPOSD strsetposd;
	DS8STRGETPOSD strgetposd;
	DS8STRSETPOSS strsetposs;
	DS8STRGETPOSS strgetposs;
	DS8STRSETENDD strsetendd;
	DS8STRSETENDS strsetends;
	DS8STRSETLOOPD strsetloopd;
	DS8STRSETLOOPS strsetloops;
	DS8PCMTEXTLANG pcmtextlang;
	DS8PCMTEXTCSET pcmtextcset;
	DS8STRGETDECSTA strgetdecsta;
	DS8STRPREOPEN strpreopen;
	DS8ENUMPCMTEXT enumpcmtext;
	}DS8OUT,*PDS8OUT;

typedef DUMU4B DUMEXPORTTYPE (*DS8VER)(void);
typedef PDS8OUT DUMEXPORTTYPE (*DS8CONST)(PDUMVOID usr,DS8CBALLOC cballoc,DS8CBFREE cbfree);
typedef PDS8OUT DUMEXPORTTYPE (*DS8CONSTUTL)(PDUMVOID usr,PDS8CBTBL cbtbl,DUMU4B tblsize);

#ifdef __cplusplus
extern "C"{
#endif
extern DUMU4B DUMEXPORTTYPE ds8_version(void);
extern PDS8OUT DUMEXPORTTYPE ds8_const(PDUMVOID usr,DS8CBALLOC cballoc,DS8CBFREE cbfree);
extern PDS8OUT DUMEXPORTTYPE ds8_const_utl(PDUMVOID usr,PDS8CBTBL cbtbl,DUMU4B tblsize);
#ifdef __cplusplus
}
#endif

#endif
