#ifndef _DUMPLAY_H_
#define _DUMPLAY_H_

#include "dumdef.h"
//#include "dumodef.h"

#define DPERR_NONE     0
#define DPERR_DUMMY    1
#define DPERR_FORMAT   2
#define DPERR_VERSION  3
#define DPERR_NULLCB   4
#define DPERR_OUTMEM   5
#define DPERR_SIZE     6
#define DPERR_FETCH    7
#define DPERR_ILLEGAL  8
#define DPERR_ZTEMPO   9
#define DPERR_SHORT   10
#define DPERR_UNDEF   11
#define DPERR_LOOPOF  12
#define DPERR_LOOPUF  13
#define DPERR_REENT   14
#define DPERR_DUMVER  15

#define DP_PCMSTA_PLAY     (1<<0)
#define DP_PCMSTA_LOOP     (1<<1)
#define DP_PCMSTA_TERM     (1<<2)
#define DP_PCMSTA_LOST     (1<<3)
#define DP_PCMSTA_INVALID  (1<<4)

#define DP_SYNC_STRREADY   0
#define DP_SYNC_STRFINISH  1

typedef int DPERRCODE,*PDPERRCODE;

typedef struct DPSTEPCOUNT_{
	DUMU1B mode; /*샂[h*/
	DUMU1B pad;
	DUMU1B bpm; /*ߓ̔*/
	DUMU1B beat; /*݂̔*/
	DUMU4B spm; /*ߓ̃Xebv*/
	DUMU4B frac; /*݂̏ߗ]Xebv*/
	DUMU2B meas; /*݂̏ߐ*/
	DUMU2B div1; /*\*/
	DUMU4B bfrac; /*݂̔]Xebv*/
	}DPSTEPCOUNT,*PDPSTEPCOUNT;

typedef struct DPCTRLSTA_{
	DUMS4B now; /*ݒl*/
	DUMS4B abs; /*ΐݒl*/
	DUMS4B rel; /*Εωl*/
	DUMS4B env; /*GF[vωl*/
	DUMS4B kmod; /*L[W[Vωl*/
	DUMS4B amod; /*I[gW[Vωl*/
	DUMS4B slur; /*X[ωl(PB)*/
	DUMS4B det; /*fB`[ωl(PB)*/
	}DPCTRLSTA,*PDPCTRLSTA;

typedef struct DPTRACKSTA_{
	DUMU4B addr; /*R}h|C^*/
	DUMU4B wait; /*cEFCg*/
	DUMU4B wdly; /*cfBC*/
	DUMU1B dev,mch; /*ΏMIDIfB@CX,`l*/
	DUMU1B f; /*tO*/
	DUMU1B nest; /*[vlXg*/
	DUMU2B lpcnt; /*[vJE^*/
	DUMU2B pad;
	}DPTRACKSTA,*PDPTRACKSTA;

#define DPTF_END   0x01 /*I*/
#define DPTF_HALT  0x02 /*~*/

typedef DPERRCODE DUMCALLTYPE (*DPCBERROR)(PDUMVOID usr,DUMU4B pos,DPERRCODE code);
typedef PDUMVOID DUMCALLTYPE (*DPCBALLOC)(PDUMVOID usr,DUMU4B size);
typedef void DUMCALLTYPE (*DPCBFREE)(PDUMVOID usr,PDUMVOID mem);
typedef DPERRCODE DUMCALLTYPE (*DPCBTIME)(PDUMVOID usr,DUMU4B time);
typedef DPERRCODE DUMCALLTYPE (*DPCBSTEP)(PDUMVOID usr,DUMU4B step);
typedef DPERRCODE DUMCALLTYPE (*DPCBNOTEOFF)(PDUMVOID usr,DUMU4B dev,DUMU4B trk,DUMU4B mch,DUMU4B note,DUMU4B vel);
typedef DPERRCODE DUMCALLTYPE (*DPCBNOTEON)(PDUMVOID usr,DUMU4B dev,DUMU4B trk,DUMU4B mch,DUMU4B note,DUMU4B vel);
typedef DPERRCODE DUMCALLTYPE (*DPCBKEYPRESS)(PDUMVOID usr,DUMU4B dev,DUMU4B trk,DUMU4B mch,DUMU4B note,DUMU4B val);
typedef DPERRCODE DUMCALLTYPE (*DPCBCTRLCHG)(PDUMVOID usr,DUMU4B dev,DUMU4B trk,DUMU4B mch,DUMU4B code,DUMU4B val);
typedef DPERRCODE DUMCALLTYPE (*DPCBPROGCHG)(PDUMVOID usr,DUMU4B dev,DUMU4B trk,DUMU4B mch,DUMU4B val);
typedef DPERRCODE DUMCALLTYPE (*DPCBCHPRESS)(PDUMVOID usr,DUMU4B dev,DUMU4B trk,DUMU4B mch,DUMU4B val);
typedef DPERRCODE DUMCALLTYPE (*DPCBPITBEND)(PDUMVOID usr,DUMU4B dev,DUMU4B trk,DUMU4B mch,DUMS4B val);
typedef PDUMVOID DUMCALLTYPE (*DPCBGETSYSX)(PDUMVOID usr,DUMU4B dev,DUMU4B trk,DUMU4B len);
typedef DPERRCODE DUMCALLTYPE (*DPCBPUTSYSX)(PDUMVOID usr,DUMU4B dev,DUMU4B trk,DUMU4B len);
typedef DPERRCODE DUMCALLTYPE (*DPCBMEMO)(PDUMVOID usr,DUMU4B trk,PDUMVOID str,DUMU4B len);
typedef DPERRCODE DUMCALLTYPE (*DPCBTEMPO)(PDUMVOID usr,DUMU4B trk,DUMU4B val);
typedef DPERRCODE DUMCALLTYPE (*DPCBEXTCMD)(PDUMVOID usr,DUMU4B trk,DUMU4B code,PDUMVOID data,DUMU4B len);
typedef DUMBOOL DUMCALLTYPE (*DPCBLOOP)(PDUMVOID usr,DUMU4B trk,DUMU4B lpcnt);
typedef PDUMVOID DUMCALLTYPE (*DPCBPCMLOAD)(PDUMVOID usr,DUMU4B prog,PDUMVOID file,DUMU4B ch,DUMU4B sw);
typedef PDUMVOID DUMCALLTYPE (*DPCBPCMDUP)(PDUMVOID usr,PDUMVOID unit);
typedef void DUMCALLTYPE (*DPCBPCMFREE)(PDUMVOID usr,PDUMVOID unit);
typedef DUMBOOL DUMCALLTYPE (*DPCBPCMPLAY)(PDUMVOID usr,PDUMVOID unit,DUMU4B flg);
typedef void DUMCALLTYPE (*DPCBPCMSTOP)(PDUMVOID usr,PDUMVOID unit);
typedef DUMBOOL DUMCALLTYPE (*DPCBPCMVOL)(PDUMVOID usr,PDUMVOID unit,DUMS4B vol);
typedef DUMBOOL DUMCALLTYPE (*DPCBPCMPAN)(PDUMVOID usr,PDUMVOID unit,DUMS4B pan);
typedef DUMBOOL DUMCALLTYPE (*DPCBPCMPIT)(PDUMVOID usr,PDUMVOID unit,DUMS4B pit);
typedef DUMBOOL DUMCALLTYPE (*DPCBPCMPOS)(PDUMVOID usr,PDUMVOID unit,DUMU4B pos);
typedef DUMU4B DUMCALLTYPE (*DPCBPCMGETSTA)(PDUMVOID usr,PDUMVOID unit);
typedef void DUMCALLTYPE (*DPCBSTROPEN)(PDUMVOID usr,DUMU4B ctxt,PDUMVOID file,DUMU4B ch,DUMU4B sw);
typedef void DUMCALLTYPE (*DPCBSTRCLOSE)(PDUMVOID usr,DUMU4B ctxt);
typedef DUMBOOL DUMCALLTYPE (*DPCBSTRPLAY)(PDUMVOID usr,DUMU4B ctxt);
typedef void DUMCALLTYPE (*DPCBSTRSTOP)(PDUMVOID usr,DUMU4B ctxt);
typedef DUMBOOL DUMCALLTYPE (*DPCBSTRVOL)(PDUMVOID usr,DUMU4B ctxt,DUMS4B vol);
typedef DUMBOOL DUMCALLTYPE (*DPCBSTRPAN)(PDUMVOID usr,DUMU4B ctxt,DUMS4B pan);
typedef DUMBOOL DUMCALLTYPE (*DPCBSTRPIT)(PDUMVOID usr,DUMU4B ctxt,DUMS4B pit);
typedef DUMBOOL DUMCALLTYPE (*DPCBSTRSYNC)(PDUMVOID usr,DUMU4B ctxt,DUMS4B desc);
typedef void DUMCALLTYPE (*DPCBSTRSETPOSD)(PDUMVOID usr,DUMU4B ctxt,DUMU8B pos);
typedef void DUMCALLTYPE (*DPCBSTRSETPOSS)(PDUMVOID usr,DUMU4B ctxt,DUMF4B pos);
typedef void DUMCALLTYPE (*DPCBSTRSETENDD)(PDUMVOID usr,DUMU4B ctxt,DUMU8B pos);
typedef void DUMCALLTYPE (*DPCBSTRSETENDS)(PDUMVOID usr,DUMU4B ctxt,DUMF4B pos);
typedef void DUMCALLTYPE (*DPCBSTRSETLOOPD)(PDUMVOID usr,DUMU4B ctxt,DUMU8B bgn,DUMU8B end);
typedef void DUMCALLTYPE (*DPCBSTRSETLOOPS)(PDUMVOID usr,DUMU4B ctxt,DUMF4B bgn,DUMF4B end);

typedef struct DPHOOKTBL_{
	DPCBERROR cberror;
	DPCBALLOC cballoc;
	DPCBFREE cbfree;
	DPCBTIME cbtime;
	DPCBSTEP cbstep;
	DPCBNOTEOFF cbnoteoff;
	DPCBNOTEON cbnoteon;
	DPCBKEYPRESS cbkeypress;
	DPCBCTRLCHG cbctrlchg;
	DPCBPROGCHG cbprogchg;
	DPCBCHPRESS cbchpress;
	DPCBPITBEND cbpitbend;
	DPCBGETSYSX cbgetsysx;
	DPCBPUTSYSX cbputsysx;
	DPCBMEMO cbmemo;
	DPCBTEMPO cbtempo;
	DPCBEXTCMD cbextcmd;
	DPCBLOOP cbloop;
	PDUMVOID disuse[15]; /*p~*/
	DPCBPCMLOAD cbpcmload;
	DPCBPCMFREE cbpcmfree;
	DPCBPCMPLAY cbpcmplay;
	DPCBPCMSTOP cbpcmstop;
	DPCBPCMVOL cbpcmvol;
	DPCBPCMPAN cbpcmpan;
	DPCBPCMPIT cbpcmpit;
	DPCBPCMDUP cbpcmdup;
	DPCBPCMPOS cbpcmpos;
	DPCBPCMGETSTA cbpcmgetsta;
	DPCBSTROPEN cbstropen;
	DPCBSTRCLOSE cbstrclose;
	DPCBSTRPLAY cbstrplay;
	DPCBSTRSTOP cbstrstop;
	DPCBSTRVOL cbstrvol;
	DPCBSTRPAN cbstrpan;
	DPCBSTRPIT cbstrpit;
	DPCBSTRSYNC cbstrsync;
	DPCBSTRSETPOSD cbstrsetposd;
	DPCBSTRSETPOSS cbstrsetposs;
	DPCBSTRSETENDD cbstrsetendd;
	DPCBSTRSETENDS cbstrsetends;
	DPCBSTRSETLOOPD cbstrsetloopd;
	DPCBSTRSETLOOPS cbstrsetloops;
	}DPHOOKTBL,*PDPHOOKTBL;

typedef struct DPIF_ DPIF,*PDPIF;

typedef DPERRCODE DUMCALLTYPE (*DPIFPURGE)(PDPIF dp);
typedef DPERRCODE DUMCALLTYPE (*DPIFRESET)(PDPIF dp);
typedef DPERRCODE DUMCALLTYPE (*DPIFTIME)(PDPIF dp,DUMU4B count,DUMU4B tempo);
typedef DPERRCODE DUMCALLTYPE (*DPIFSTEP)(PDPIF dp,DUMU4B count,DUMU4B tempo);
typedef DUMU4B DUMCALLTYPE (*DPIFGETRIGHT)(PDPIF dp,PDUMVOID buf,DUMU4B len);
typedef DUMU4B DUMCALLTYPE (*DPIFGETTITLE)(PDPIF dp,PDUMVOID buf,DUMU4B len);
typedef DUMU4B DUMCALLTYPE (*DPIFGETDWPNAME)(PDPIF dp,PDUMVOID buf,DUMU4B len);
typedef DPERRCODE DUMCALLTYPE (*DPIFADDDWP)(PDPIF dp,PDUMVOID data,DUMU4B len);
typedef DUMU4B DUMCALLTYPE (*DPIFGETERRLOC)(PDPIF dp);
typedef DUMU4B DUMCALLTYPE (*DPIFGETTRKS)(PDPIF dp);
typedef DUMU4B DUMCALLTYPE (*DPIFGETDIV1)(PDPIF dp);
typedef DUMU4B DUMCALLTYPE (*DPIFGETLOOPCOUNT)(PDPIF dp);
typedef DUMBOOL DUMCALLTYPE (*DPIFISEND)(PDPIF dp);
typedef DPERRCODE DUMCALLTYPE (*DPIFALLNOTEOFF)(PDPIF dp,DUMU4B devf,DUMU4B mchf);
typedef DPERRCODE DUMCALLTYPE (*DPIFUPDKEYPRESS)(PDPIF dp,DUMU4B trk,DUMU4B devf,DUMU4B mchf,DUMU4B note);
typedef DPERRCODE DUMCALLTYPE (*DPIFUPDCTRLCHG)(PDPIF dp,DUMU4B trk,DUMU4B devf,DUMU4B mchf,DUMU4B code);
typedef DPERRCODE DUMCALLTYPE (*DPIFUPDPROGCHG)(PDPIF dp,DUMU4B trk,DUMU4B devf,DUMU4B mchf);
typedef DPERRCODE DUMCALLTYPE (*DPIFUPDCHPRESS)(PDPIF dp,DUMU4B trk,DUMU4B devf,DUMU4B mchf);
typedef DPERRCODE DUMCALLTYPE (*DPIFUPDPITBEND)(PDPIF dp,DUMU4B trk,DUMU4B devf,DUMU4B mchf);
typedef DPERRCODE DUMCALLTYPE (*DPIFGETSTEPCOUNT)(PDPIF dp,PDPSTEPCOUNT tbl,DUMU4B tbllen);
typedef DPERRCODE DUMCALLTYPE (*DPIFGETTRACKSTA)(PDPIF dp,DUMU4B trk,PDPTRACKSTA tbl,DUMU4B tbllen);
typedef DPERRCODE DUMCALLTYPE (*DPIFGETCCSTA)(PDPIF dp,DUMU4B dev,DUMU4B mch,DUMU4B code,PDPCTRLSTA tbl,DUMU4B tbllen);
typedef DPERRCODE DUMCALLTYPE (*DPIFGETPBSTA)(PDPIF dp,DUMU4B dev,DUMU4B mch,PDPCTRLSTA tbl,DUMU4B tbllen);
typedef DPERRCODE DUMCALLTYPE (*DPIFGETKPSTA)(PDPIF dp,DUMU4B dev,DUMU4B mch,DUMU4B note,PDPCTRLSTA tbl,DUMU4B tbllen);
typedef DPERRCODE DUMCALLTYPE (*DPIFGETCPSTA)(PDPIF dp,DUMU4B dev,DUMU4B mch,PDPCTRLSTA tbl,DUMU4B tbllen);
typedef DPERRCODE DUMCALLTYPE (*DPIFGETTEMPOSTA)(PDPIF dp,PDPCTRLSTA tbl,DUMU4B tbllen);
typedef DPERRCODE DUMCALLTYPE (*DPIFGETONVELSTA)(PDPIF dp,DUMU4B trk,PDPCTRLSTA tbl,DUMU4B tbllen);
typedef DPERRCODE DUMCALLTYPE (*DPIFGETOFFVELSTA)(PDPIF dp,DUMU4B trk,PDPCTRLSTA tbl,DUMU4B tbllen);
typedef DPERRCODE DUMCALLTYPE (*DPIFGETRGATESTA)(PDPIF dp,DUMU4B trk,PDPCTRLSTA tbl,DUMU4B tbllen);
typedef DPERRCODE DUMCALLTYPE (*DPIFGETSGATESTA)(PDPIF dp,DUMU4B trk,PDPCTRLSTA tbl,DUMU4B tbllen);
typedef DUMU4B DUMCALLTYPE (*DPIFGETLANG)(PDPIF dp,PDUMVOID buf,DUMU4B len);
typedef DUMU4B DUMCALLTYPE (*DPIFGETCSET)(PDPIF dp,PDUMVOID buf,DUMU4B len);

typedef PDPIF DUMEXPORTTYPE (*DPCONST)(DUMU4B devs,PDUMVOID data,DUMU4B datalen,PDPHOOKTBL ht,DUMU4B htlen,PDUMVOID usr,PDPERRCODE err);
typedef DUMU4B DUMEXPORTTYPE (*DPVER)(void);

typedef struct DPIF_{
	DPIFPURGE purge;
	DPIFRESET reset;
	DPIFTIME time;
	DPIFSTEP step;
	DPIFGETRIGHT getright;
	DPIFGETTITLE gettitle;
	DPIFGETDWPNAME getdwpname;
	DPIFADDDWP adddwp;
	DPIFGETERRLOC geterrloc;
	DPIFGETTRKS gettrks;
	DPIFGETDIV1 getdiv1;
	DPIFGETLOOPCOUNT getloopcount;
	DPIFISEND isend;
	DPIFALLNOTEOFF allnoteoff;
	DPIFUPDKEYPRESS updkeypress;
	DPIFUPDCTRLCHG updctrlchg;
	DPIFUPDPROGCHG updprogchg;
	DPIFUPDCHPRESS updchpress;
	DPIFUPDPITBEND updpitbend;
	DPIFGETSTEPCOUNT getstepcount;
	DPIFGETTRACKSTA gettracksta;
	DPIFGETCCSTA getccsta;
	DPIFGETPBSTA getpbsta;
	DPIFGETKPSTA getkpsta;
	DPIFGETCPSTA getcpsta;
	DPIFGETTEMPOSTA gettemposta;
	DPIFGETONVELSTA getonvelsta;
	DPIFGETOFFVELSTA getoffvelsta;
	DPIFGETRGATESTA getrgatesta;
	DPIFGETSGATESTA getsgatesta;
	DPIFGETLANG getlang;
	DPIFGETCSET getcset;
	}DPIF,*PDPIF;

#ifdef __cplusplus
extern "C"{
#endif
PDPIF DUMEXPORTTYPE dp_const(DUMU4B devs,PDUMVOID data,DUMU4B datalen,PDPHOOKTBL ht,
DUMU4B htlen,PDUMVOID usr,PDPERRCODE err);
DUMU4B DUMEXPORTTYPE dp_version(void);
#ifdef __cplusplus
}
#endif

#endif
