#ifndef _DUMWDEC_H_
#define _DUMWDEC_H_

#include "dumdef.h"
//#include "dumodef.h"

typedef int DWERRCODE,*PDWERRCODE;
typedef int DWSETRES,*PDWSETRES;

typedef struct DWDECSTA_{
	DUMU1B ch; /*Tv`l*/
	DUMU1B dep; /*TvfvX(oCgP)*/
	DUMU1B cap; /*vO\(DW_CAP_* gݍ킹)*/
	DUMU1B ver; /*\̃@[W(vODWDECSTAVERSION)*/
	DUMU4B freq; /*Tv[g(Hz)*/
	DUMU4B samples; /*Tv*/
	DUMU4B lbgn,lend; /*(ver1ȍ~)[vn[,I[*/
	}DWDECSTA,*PDWDECSTA;

#define DWDECSTAVERSION 1

#define DW_CAP_GETLENGTH (1<<0) /*Tv擾ł*/
#define DW_CAP_GETPOS    (1<<1) /*fBR[hʒu擾ł*/
#define DW_CAP_SETPOS    (1<<2) /*fBR[hʒuύXł*/
#define DW_CAP_SETEND    (1<<3) /*fBR[hI[ʒuݒł*/
#define DW_CAP_SETLOOP   (1<<4) /*[vʒuݒł*/

#define DW_ERR_NONE    0
#define DW_ERR_FATAL   1

#define DW_SET_SUCCESS   0
#define DW_SET_UNSTABLE  1
#define DW_SET_FATAL     2
#define DW_SET_UNSUPPORT 3

#define DW_TEXT_OTHER   0
#define DW_TEXT_TITLE   (-1)
#define DW_TEXT_RIGHT   (-2)
#define DW_TEXT_ALBUM   (-3)
#define DW_TEXT_ARTIST  (-4)
#define DW_TEXT_DATE    (-5)
#define DW_TEXT_NUMBER  (-6)
#define DW_TEXT_GENRE   (-7)
#define DW_TEXT_SUBJECT (-8)

typedef struct DWUTL_ DWUTL,*PDWUTL;

typedef DUMBOOL DUMCALLTYPE (*DWCBFINDTEXT)(LPVOID tag,DUMCSTR text,DUMCSTR lang,DUMCSTR cset);

typedef PDUMVOID DUMCALLTYPE (*DWUTLALLOC)(PDWUTL utl,DUMU4B size);
typedef void DUMCALLTYPE (*DWUTLFREE)(PDWUTL utl,PDUMVOID mem);
typedef DUMS4B DUMCALLTYPE (*DWUTLOPEN)(PDWUTL utl,DUMCSTR file,DUMU4B f);
typedef DUMS4B DUMCALLTYPE (*DWUTLOPENERRCODE)(PDWUTL utl);
typedef DUMBOOL DUMCALLTYPE (*DWUTLISOPENERR)(PDWUTL utl,DUMS4B fd);
typedef void DUMCALLTYPE (*DWUTLCLOSE)(PDWUTL utl,DUMS4B fd);
typedef DUMU8B DUMCALLTYPE (*DWUTLSEEK)(PDWUTL utl,DUMS4B fd,DUMS8B pos,DUMS4B mode);
typedef DUMU8B DUMCALLTYPE (*DWUTLREAD)(PDWUTL utl,DUMS4B fd,PDUMVOID buf,DUMU8B size);
typedef DUMU8B DUMCALLTYPE (*DWUTLWRITE)(PDWUTL utl,DUMS4B fd,PDUMVOID buf,DUMU8B size);

typedef struct DWUTL_{
	DWUTLALLOC alloc;
	DWUTLFREE free;
	DWUTLOPEN open;
	DWUTLOPENERRCODE openerrcode;
	DWUTLISOPENERR isopenerr;
	DWUTLCLOSE close;
	DWUTLSEEK seek;
	DWUTLREAD read;
	DWUTLWRITE write;
	}DWUTL,*PDWUTL;

#define DW_FILE_READ    (1<<0)
#define DW_FILE_WRITE   (1<<1)
#define DW_FILE_NEW     (1<<2)
#define DW_FILE_EXCL    (1<<3)
#define DW_FILE_APPEND  (1<<4)
#define DW_FILE_RDWR    (DW_FILE_READ|DW_FILE_WRITE)

#define DW_SEEK_SET     0
#define DW_SEEK_CUR     1
#define DW_SEEK_END     2

typedef DUMU4B DUMEXPORTTYPE (*DWVER)(void);
typedef PDUMVOID DUMEXPORTTYPE (*DWCREDIT)(void);
typedef DUMU4B DUMEXPORTTYPE (*DWPCMCOUNT)(PDWUTL utl,DUMCSTR file);
typedef void DUMEXPORTTYPE (*DWENUMPCMTEXT)(PDWUTL utl,DUMCSTR file,DUMU4B ch,DUMS4B kind,DWCBFINDTEXT cbfindtext,LPVOID tag);
typedef DUMU4B DUMEXPORTTYPE (*DWPCMTEXTCOUNT)(PDWUTL utl,DUMCSTR file,DUMU4B ch);
typedef DUMU4B DUMEXPORTTYPE (*DWPCMTEXT)(PDWUTL utl,DUMCSTR file,DUMU4B ch,DUMS4B idx,DUMCSTRBUF buf,DUMU4B size);
typedef DUMU4B DUMEXPORTTYPE (*DWPCMTEXTCSET)(PDWUTL utl,DUMCSTR file,DUMU4B ch,DUMS4B idx,DUMCSTRBUF buf,DUMU4B size);
typedef DUMU4B DUMEXPORTTYPE (*DWPCMTEXTLANG)(PDWUTL utl,DUMCSTR file,DUMU4B ch,DUMS4B idx,DUMCSTRBUF buf,DUMU4B size);
typedef PDWDECSTA DUMEXPORTTYPE (*DWOPEN)(PDWUTL utl,int mode,DUMCSTR file,DUMU4B ch,DUMU4B sw);
typedef DUMU4B DUMEXPORTTYPE (*DWDECODE)(PDWUTL utl,PDWDECSTA fp,PDUMVOID buf,DUMU4B size);
typedef DWSETRES DUMEXPORTTYPE (*DWSETPOS)(PDWUTL utl,PDWDECSTA fp,DUMU8B pos);
typedef DUMU8B DUMEXPORTTYPE (*DWGETPOS)(PDWUTL utl,PDWDECSTA fp);
typedef DWSETRES DUMEXPORTTYPE (*DWSETEND)(PDWUTL utl,PDWDECSTA fp,DUMU8B pos);
typedef DWSETRES DUMEXPORTTYPE (*DWSETLOOP)(PDWUTL utl,PDWDECSTA fp,DUMU8B bgn,DUMU8B end);
typedef void DUMEXPORTTYPE (*DWSWITCH)(PDWUTL utl,PDWDECSTA fp,DUMU4B sw);
typedef DUMBOOL DUMEXPORTTYPE (*DWISEND)(PDWUTL utl,PDWDECSTA fp);
typedef void DUMEXPORTTYPE (*DWCLOSE)(PDWUTL utl,PDWDECSTA fp);

#define DWPCMTEXTCS DWPCMTEXTCSET

#ifdef __cplusplus
extern "C"{
#endif
DUMU4B DUMEXPORTTYPE dw_version(void);
PDUMVOID DUMEXPORTTYPE dw_credit(void);
DUMU4B DUMEXPORTTYPE dw_pcmcount(PDWUTL utl,DUMCSTR file);
void DUMEXPORTTYPE dw_enumpcmtext(PDWUTL utl,DUMCSTR file,DUMU4B ch,DUMS4B kind,DWCBFINDTEXT cbfindtext,LPVOID tag);
DUMU4B DUMEXPORTTYPE dw_pcmtextcount(PDWUTL utl,DUMCSTR file,DUMU4B ch);
DUMU4B DUMEXPORTTYPE dw_pcmtext(PDWUTL utl,DUMCSTR file,DUMU4B ch,DUMS4B idx,DUMCSTRBUF buf,DUMU4B size);
DUMU4B DUMEXPORTTYPE dw_pcmtextcs(PDWUTL utl,DUMCSTR file,DUMU4B ch,DUMS4B idx,DUMCSTRBUF buf,DUMU4B size);
DUMU4B DUMEXPORTTYPE dw_pcmtextcset(PDWUTL utl,DUMCSTR file,DUMU4B ch,DUMS4B idx,DUMCSTRBUF buf,DUMU4B size);
DUMU4B DUMEXPORTTYPE dw_pcmtextlang(PDWUTL utl,DUMCSTR file,DUMU4B ch,DUMS4B idx,DUMCSTRBUF buf,DUMU4B size);
PDWDECSTA DUMEXPORTTYPE dw_open(PDWUTL utl,int mode,DUMCSTR file,DUMU4B ch,DUMU4B sw);
DUMU4B DUMEXPORTTYPE dw_decode(PDWUTL utl,PDWDECSTA fp,PDUMVOID buf,DUMU4B size);
DWSETRES DUMCALLTYPE dw_setpos(PDWUTL utl,PDWDECSTA fp,DUMU8B pos);
DUMU8B DUMCALLTYPE dw_getpos(PDWUTL utl,PDWDECSTA fp);
DWSETRES DUMCALLTYPE dw_setend(PDWUTL utl,PDWDECSTA fp,DUMU8B pos);
DWSETRES DUMCALLTYPE dw_setloop(PDWUTL utl,PDWDECSTA fp,DUMU8B begin,DUMU8B end);
void DUMEXPORTTYPE dw_switch(PDWUTL utl,PDWDECSTA fp,DUMU4B sw);
DUMBOOL DUMEXPORTTYPE dw_isend(PDWUTL utl,PDWDECSTA fp);
void DUMEXPORTTYPE dw_close(PDWUTL utl,PDWDECSTA fp);
#ifdef __cplusplus
}
#endif

#endif
